<template>

    <v-card max-width="600" :elevation="11" class="pa-6">
        <v-card-title>Add Rule</v-card-title>
        <v-alert v-if="err != ''" dense text type="error">
            {{err}}
        </v-alert>
        <v-alert v-if="ok != ''" dense text type="success">
            {{success}}
        </v-alert>
        <v-form ref="form" v-model="valid">
            <v-select :items="rules"
                      item-text="name"
                      :hint="rule.description"
                      v-model="rule"
                      return-object
                      required
                      :rules="required"
                      single-line/>
        </v-form>
        <v-card-actions>
            <v-btn color="primary" @click="Back">
                Back
            </v-btn>
            <v-spacer/>
            <v-btn color="primary" :disabled="!valid" @click="Create">
                Create
            </v-btn>
        </v-card-actions>
    </v-card>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Prop} from 'vue-property-decorator';
    import {RulePrincipalResponse} from "../../../classLibrary/core/rulePrincipalResponse";
    import {coreApi} from "../init";
    import {FloorResponse} from "../../../classLibrary/core/floorResponse";
    import {Validable} from "../mixins/Validable";


    @Component
    export default class AddRuleToFloor extends Validable {
        @Prop() floorId!: string

        @Prop() closeF!: () => void;
        @Prop() createF!: () => void;

        rules: RulePrincipalResponse[] = [];
        rule: RulePrincipalResponse = new RulePrincipalResponse('', '', '', '', '', [])
        valid: boolean = false;
        required = [
            (v: any) => !!v || 'Required',
        ]

        get Form(): any {
            return this.$refs['form'];
        }

        async Create() {
            const valid = this.Form.validate();
            if (valid) {
                const r = await coreApi.Post<FloorResponse>(`ActiveRule?floorId=${this.floorId}&ruleId=${this.rule.id}`);
                if (r.success) {
                    this.ok = `Added Rule to floor!`;
                    this.createF();
                } else {
                    this.err = r.error!;
                }
            } else {
                this.err = "";
            }
        }

        async mounted() {
            this.err = '';
            const ruleResult = await coreApi.Get<RulePrincipalResponse[]>('Rule');
            if (ruleResult.success) {
                this.rules = ruleResult.Ok!;
            } else {
                this.err = ruleResult.error!;
                this.rules = [];
            }
        }

        Back() {
            this.closeF();
        }

    }
</script>
